# CMF imports
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import AddPortalContent

# CPS imports
from Products.CPSCore.CPSBase import CPSBaseDocument, CPSBase_adder

# ZWiki imports and "hacks" to transform ZWiki product into CPSZWiki !!! ;-)
from Products.ZWiki.__init__ import *
from Products.ZWiki.CMFInit import *
from Products.ZWiki import CMFInit
ZWiki_fti_dico = factory_type_information[0]

# Package params
__doc__ = """
CPSZWiki
"""
__version__ = "0-0-1"


# CPSZWiki imports
import CPSZWiki

# Factory type information of CPSZWiki product
CPSZWiki_fti = ()
CPSZWiki_fti_dico = ZWiki_fti_dico.copy()
CPSZWiki_fti_dico.update(
    {'id' : 'CPSZWiki',
     'meta_type' : 'CPSZWiki',
     'title' : 'CPSZWiki', # i18n : 'portal_type_CPSZWiki_title', 
     'description' : 'A wiki engine for CPS 3.x based on ZWiki.', # i18n : 'portal_type_CPSZWiki_description',
     'icon' : 'CPSZWiki_icon.gif',
     'content_icon' : 'CPSZWiki_icon.gif',
     'product' : 'CPSZWiki',
     'factory' : 'addCPSZWiki',
     'filter_content_types' : 0,
     'allowed_content_types' : (),
     'allow_discussion' : 0,
     'immediate_view': 'editform', 
     #'cps_proxy_type' : 'document',
     #'cps_is_searchable' : 1,
     },
)

for action in CPSZWiki_fti_dico['actions']:
    if action['category'] == 'object_actions': # and action['id'] <> 'contents':
        action['category'] = 'object'
CPSZWiki_fti = (CPSZWiki_fti_dico, )

contentClasses = ()
contentConstructors = ()
fti = ()

contentClasses += (CPSZWiki.CPSZWiki,)
contentConstructors += (CPSZWiki.addCPSZWiki,)
fti += CPSZWiki_fti


def initialize(registrar):
       utils.ContentInit('CPSZWiki Content', 
                         content_types = contentClasses,
                         permission = Permissions.Add,
                         extra_constructors = contentConstructors,
                         fti = fti,
                         ).initialize(registrar)
       # also register skin dirs with FileSystemSite if installed
       registerDirectory('../ZWiki/skins', globals())
       registerDirectory('skins', globals())


original_manage_afterAdd = manage_afterAdd
def manage_afterAdd(self, item, container):
    roles = self.valid_roles()
    self.manage_permission(permission_to_manage = Permissions.View, roles = roles, acquire = 0)
    original_manage_afterAdd(self, item, container)
CPSZWiki.CPSZWiki.manage_afterAdd = manage_afterAdd

CPSZWiki.CPSZWiki.manage_afterClone = manage_afterClone

CPSZWiki.CPSZWiki.manage_beforeDelete = manage_beforeDelete

CPSZWiki.CPSZWiki.manage_addProperty = manage_addProperty

CPSZWiki.CPSZWiki.manage_delProperties = manage_delProperties

CPSZWiki.CPSZWiki.manage_changeProperties = manage_changeProperties

CPSZWiki.CPSZWiki.manage_editProperties = manage_editProperties